<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['aidevicedept:aidevicedept:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['aidevicedept:aidevicedept:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['aidevicedept:aidevicedept:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['aidevicedept:aidevicedept:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getDeptList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="aidevicedeptList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="部门名称" align="center" prop="mapDeptName" />
      <el-table-column label="部门类型" align="center" prop="deptProtype" :formatter="deptProtypeFormat" />
      <el-table-column label="指挥中心" align="center" prop="isCommandCenter" :formatter="isCommandCenterFormat" />
      <el-table-column label="添加时间" align="center" prop="createTime"/>
      <el-table-column label="修改时间" align="center" prop="updateTime"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['aidevicedept:aidevicedept:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['aidevicedept:aidevicedept:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getDeptList"
    />

    <!-- 添加或修改AI对应部门对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="部门名称" prop="mapDeptId">
          <treeselect :options="deptOptions" v-model="form.mapDeptId" :show-count="true" placeholder="请选择部门名称"
                      @select="hx"/>
        </el-form-item>
        <el-form-item label="部门类型" prop="deptProtype">
          <el-select v-model="form.deptProtype" placeholder="请输入部门类型">
            <el-option
              v-for="item in deptProtypeOptions"
              :key="item.value"
              :value="item.value"
              :label="item.label"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="指挥中心" prop="isCommandCenter">
          <el-radio v-model='form.isCommandCenter' :label='0'>否</el-radio>
          <el-radio v-model='form.isCommandCenter' :label='1'>是</el-radio>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listAidevicedept, getAidevicedept, delAidevicedept, addAidevicedept, updateAidevicedept } from "@/api/centerMonitor/aidevicedept/aidevicedept";
import {treeselect} from "@/api/system/dept";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "Aidevicedept",
  components: {
    Treeselect
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // AI对应部门表格数据
      aidevicedeptList: [],
      // 部门树选项
      deptOptions: undefined,
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        deviceType: null,
        deviceCode: null,
        deviceId: null,
        deviceName: null,
        mapDeptId: null,
        mapDeptName: null,
        deptProtype: null,
        createName: null,
        updateName: null,
        dataStatus: null,
        deptId: null,
        deptName: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        mapDeptId: [
          { required: true, message: "部门名称不能为空", trigger: "blur" }
        ],
        deptProtype: [
          { required: true, message: "部门类型不能为空", trigger: "blur" }
        ],
        isCommandCenter: [
          { required: true, message: "请选择是否指挥中心", trigger: "blur" }
        ],
      },
      deptProtypeOptions: [
        {value: "1", label: '责任单位，接收推送'},
        {value: "2", label: '查看单位'}
      ],
      isCommandCenterOptions: [
        {value: "0", label: '否'},
        {value: "1", label: '是'}
      ],
    };
  },
  props: {
    sonId: null,
    sonCode:null,
    sonName:null,
    sonType:null
  },
  created() {
    this.getDeptList();
    this.getTreeselect();
  },
  methods: {
    // 部门类型字典翻译
    deptProtypeFormat(row, column) {
      var name = "";
      this.deptProtypeOptions.forEach(function (item, index) {
        if (row.deptProtype == item.value) {
          name = item.label;
        }
      });
      return name;
    },
    // 是否指挥中心字典翻译
    isCommandCenterFormat(row, column) {
      var name = "";
      this.isCommandCenterOptions.forEach(function (item, index) {
        if (row.isCommandCenter == item.value) {
          name = item.label;
        }
      });
      return name;
    },
    /** 查询AI对应部门列表 */
    getDeptList() {
      this.loading = true;
      this.queryParams.deviceId = this.sonId;
      listAidevicedept(this.queryParams).then(response => {
        this.aidevicedeptList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data;
      });
    },
    //部门ID、部门名称赋值
    hx(node) {
      this.form.mapDeptId = node.id;
      this.form.mapDeptName = node.label
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        deviceType: null,
        deviceCode: null,
        deviceId: null,
        deviceName: null,
        mapDeptId: null,
        mapDeptName: null,
        deptProtype: null,
        createBy: null,
        createName: null,
        createTime: null,
        updateBy: null,
        updateName: null,
        updateTime: null,
        dataStatus: "data_status_1",
        deptId: null,
        deptName: null,
        isCommandCenter: 0
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getDeptList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.form.deviceType = this.sonType;
      this.form.deviceCode = this.sonCode;
      this.form.deviceId = this.sonId;
      this.form.deviceName = this.sonName;
      this.open = true;
      this.title = "添加AI对应部门";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getAidevicedept(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改AI对应部门";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateAidevicedept(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getDeptList();
            });
          } else {
            addAidevicedept(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getDeptList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除数据项？').then(function() {
        return delAidevicedept(ids);
      }).then(() => {
        this.getDeptList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('center-monitor/aidevicedept/export', {
        ...this.queryParams
      }, `aidevicedept_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
